//-----------------------------------------------------------------------
// USER.H:  Definitions for the user_interface (view) class
//-----------------------------------------------------------------------

#ifndef USER_H__
#define USER_H__

#include "stroke.h"
#include "data.h"

class user_interface : public CScrollView
{
protected: // create from serialization only
	virtual
	~user_interface();
	 user_interface();
	DECLARE_DYNCREATE(user_interface)

private:
	data_interface	*GetDocument( void );
	drawing_element	*dwg_object;
	unsigned		display_as_text : 1;

public:
	void new_drawing_element( drawing_element *element );

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

	protected:
	//{{AFX_MSG(user_interface)
	afx_msg void OnDisplayastext();
	afx_msg void OnUpdateDisplayastext(CCmdUI* pCmdUI);
	afx_msg void OnLButtonDown( UINT flags, CPoint point );
	afx_msg void OnMouseMove( UINT flags, CPoint point );
	afx_msg void OnLButtonUp( UINT flags, CPoint point );
	afx_msg	void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnTraceline();
	//}}AFX_MSG

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(user_interface)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	protected:
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnUpdate( CView* pSender, LPARAM lHint, CObject* pHint );
	virtual void OnInitialUpdate();
	//}}AFX_VIRTUAL

	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in sketcvw.cpp
inline data_interface* user_interface::GetDocument()
   { return (data_interface*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

#endif // USER_H__
